#include <stdio.h>
#include <strings.h>
#include "show-bytes.c"

void test_show_bytes(int val)
{
    int ival = val;
    show_int(ival);
    printf ("\n");

    float fval = (float) ival;
    show_float(fval);
    printf ("\n");

    int *pval = &ival;
    show_pointer(pval);
    printf ("\n");
}

void simple_show()
{
    int val = 0x12345678;
    byte_pointer valp = (byte_pointer) &val;
    show_bytes(valp, 1); /* A. */
    printf ("\n");
    show_bytes(valp, 2); /* B. */
    printf ("\n");
    show_bytes(valp, 3); /* C. */
    printf ("\n");
}

void float_eg()
{
    int x = 3490593;
    float f = (float) x;
    show_int(x);
    printf ("\n");
    show_float(f);
    printf ("\n");
}

void string_eg()
{
    char *s = "ABCDEF";
    show_bytes((unsigned char *)s, strlen(s)+1); 
    printf ("\n");
}

void show_twocomp() 
{
    short int x = 12345; 
    short int mx = -x; 
    
    show_bytes((byte_pointer) &x, sizeof(short int)); 
    printf ("\n");
    show_bytes((byte_pointer) &mx, sizeof(short int)); 
    printf ("\n");
}

int main(int argc, char *argv[])
{
    int val = 12345;

    if (argc > 1) {
      if (argv[1][0] == '0' && argv[1][1] == 'x')
	sscanf(argv[1]+2, "%x", &val);
      else
	sscanf(argv[1], "%d", &val);
      printf("Calling test_show_bytes\n");
      test_show_bytes(val);
    } else {
      printf("Calling show_twocomp\n");
      show_twocomp();
      printf("Calling simple_show\n");
      simple_show();
      printf("Calling float_eg\n");
      float_eg();
      printf("Calling string_eg\n");
      string_eg();
    }
    return 0;
}
